#requires -version 2.0 

<#
 -----------------------------------------------------------------------------
 Script: New-WordDoc.ps1
 Version: 0.1
 Author: Jeffery Hicks
    http://jdhitsolutions.com/blog
    http://twitter.com/JeffHicks
    http://www.ScriptingGeek.com
 Date: 5/8/2012
 Keywords:
 Comments:
 
    This is the version used in the San Diego DeepDive demo.
    Microsoft Word must be installed

    "Those who forget to script are doomed to repeat their work."

  ****************************************************************
  * DO NOT USE IN A PRODUCTION ENVIRONMENT UNTIL YOU HAVE TESTED *
  * THOROUGHLY IN A LAB ENVIRONMENT. USE AT YOUR OWN RISK.  IF   *
  * YOU DO NOT UNDERSTAND WHAT THIS SCRIPT DOES OR HOW IT WORKS, *
  * DO NOT USE IT OUTSIDE OF A SECURE, TEST SETTING.             *
  ****************************************************************
 -----------------------------------------------------------------------------
 #>
 
#where are we going to save the new file?
$savepath="C:\work\MyDoc.docx"

#load assemblies? Not really needed.
Add-Type -AssemblyName Office
Add-Type -AssemblyName Microsoft.Office.Interop.Word

#create the WORD COM object
$word=new-object -ComObject "Word.Application"

#an alternate approach but still really a COM object
#$word=new-object -TypeName Microsoft.Office.Interop.Word.ApplicationClass

#create a new document
$doc=$word.documents.Add()

#make it visible
$word.Visible=$True

#give the document focus
$selection=$word.Selection

#insert some content
$selection.TypeText((Get-Date))

#insert a return
$selection.TypeParagraph()

#insert some more text
$os=Get-WmiObject -class win32_OperatingSystem
$selection.TypeText("Operating System Information for $($os.CSName)")

#get an array of class properties, excluding System properties
$os.properties | select Name | 
 foreach -begin {
   #define an empty array
   $props=@()
  } -process {
   #add each property name to the array
   $props+="$($_.name)"
   }

#text must be explicit strings
$selection.TypeText(($os | Select -Property $props | Out-String))

#save it
#$doc.SaveAs([ref]$savepath)    
#$doc.Close()
    
#exit word
#$word.quit()
