#requires -version 2.0

<#
 -----------------------------------------------------------------------------
 Script: New-WordDoc2.ps1
 Version: 0.1
 Author: Jeffery Hicks
    http://jdhitsolutions.com/blog
    http://twitter.com/JeffHicks
    http://www.ScriptingGeek.com
 Date: 5/8/2012
 Keywords:
 Comments:
    Add some style and formatting to a Powershell generated Word document
    Microsoft Word must be installed.
    This is the version used in the San Diego DeepDive demo.

    "Those who forget to script are doomed to repeat their work."

  ****************************************************************
  * DO NOT USE IN A PRODUCTION ENVIRONMENT UNTIL YOU HAVE TESTED *
  * THOROUGHLY IN A LAB ENVIRONMENT. USE AT YOUR OWN RISK.  IF   *
  * YOU DO NOT UNDERSTAND WHAT THIS SCRIPT DOES OR HOW IT WORKS, *
  * DO NOT USE IT OUTSIDE OF A SECURE, TEST SETTING.             *
  ****************************************************************
 -----------------------------------------------------------------------------
 #>
 
#create the WORD COM object
$word=new-object -ComObject "Word.Application"

#create a new document
$doc=$word.documents.Add()

#make it visible if you want to watch what happens
#$word.Visible=$True

#give the document focus
$selection=$word.Selection

$selection.Style="Title"
$selection.TypeText("Operating System Report")
$selection.TypeParagraph()

#format
$selection.Font.Color="wdColorGreen"

#insert some content
$selection.TypeText((Get-Date))

$selection.font.Color="wdColorAutomatic"

#insert a return
$selection.TypeParagraph()

#insert some more text
$os=Get-WmiObject -class win32_OperatingSystem

$selection.Font.Size=12
$selection.TypeText("Operating System Information for $($os.CSName)")

#get an array of class properties
$os.properties | select Name | foreach -begin {$props=@()} -proc {$props+="$($_.name)"}

#text must be strings
$selection.Font.Size=10
$selection.Font.Name="Consolas"
#adjust paragraph formatting
$selection.ParagraphFormat.SpaceBefore=0
$selection.ParagraphFormat.SpaceAfter=0
$selection.ParagraphFormat.LineSpacingRule="wdLineSpaceSingle"

#write the text
$selection.TypeText(($os | Select -Property $props | Out-String))

$selection.Font.size=8
$selection.Font.Name="Calibri"
$selection.Font.Italic=$True
$selection.Font.Bold=$True

[string]$by="Report created by {0}\{1} {2}" -f $env:userdomain,$env:username,(Get-Date)

$selection.TypeText($by)

#save it
#where are we going to save the new file
$savepath="C:\work\MyDoc2.docx"

<#
bug in PowerShell v3 beta with SaveAs method so you may want to comment out 
the rest of this script and manually view/save document
#>
$doc.SaveAs([ref]$savepath)    

#close the file
$doc.Close()
    
#exit Word
$word.quit()

#uncomment if you want to automatically re-open the document
#Invoke-Item $savepath